<?

require "haml/HamlParser.php";


class HamlParser2 extends HamlParser
{ // by Benyx. remove 'private' from toTree

	function parseString($str)
	{
		$this->lineNumber = 0;
		$this->filename = 'nofilename';
		$str = trim($str);
		return $this->toTree($str)->render();
	}
	
	function parse($filename) {
		global $locale;
		$this->lineNumber = 0;
		$this->filename = $filename;
		$source = file_get_contents($filename); 
	// remove BOM
		if(substr($source, 0, 3) == pack('CCC', 0xef, 0xbb, 0xbf)) 
			$source = substr($source, 3);;
		$source = "\n\n".trim($source);

		$source = strtr($source,"\t",'  ');
		$source = self::make_windows_eols($source);
		return $this->toTree($source)->render();
	}

	static function make_windows_eols($s)
	{
		$s = preg_replace("/(?<!\\n)\\r+(?!\\n)/", "\r\n", $s); //replace just CR with CRLF 
		$s = preg_replace("/(?<!\\r)\\n+(?!\\r)/", "\r\n", $s); //replace just LF with CRLF 
		$s = preg_replace("/(?<!\\r)\\n\\r+(?!\\n)/", "\r\n", $s); //replace misordered LFCR with CRLF
		return $s;
	}
	
}

class haml_parser 
{
	public static $me = false;
	
	static function init()
	{
		self::$me = new HamlParser2(array());
	}
	
	static public function  parseString($str)
	{
		return self::$me->parseString($str);
	}
	
	static public function  parse($str)
	{
		return self::$me->parse($str);
	}

}


?>